var assert = require('mocha');
var cpyParser = require('./cobol-copybook.parser');
var fs = require('fs');

describe('Read and parse copybook definitions', function(){
    it('should parse cobol copybook statement iterator model', function(){
        var script = new String(fs.readFileSync('./src/cobol/CCP0001.CPY'));
        
        var sttIterator = cpyParser.getStatemantIterator(script);
        var statement = {done: false};
        var countStatements = 0;
        var countStatementsWithDot = 0;
        fs.writeFileSync('./readed-statements.CCP0001.CPY.txt', '');
        while( statement.done==false ){
            statement = sttIterator.next();
            if(statement.value === undefined) continue;
            countStatements++;
            countStatementsWithDot += (statement.value.endsWith('.') ? 1: 0);
            fs.appendFileSync('./readed-statements.CCP0001.CPY.txt', statement.value + '\n');
        }
        console.log(`Statements: ${countStatements}, with dot: ${countStatementsWithDot}`);
        assert(countStatements === countStatementsWithDot, 'error');
    });
    
    it('should parse cobol copybook', function(){
        var script = new String(fs.readFileSync('./src/cobol/CCP0001.CPY'));
        
        var book = cpyParser.loadBook(script);
        
        console.log(book);
        fs.writeFileSync('./parsed-book.CCP0001.CPY.json', JSON.stringify(book, null, 2));
        
        
        assert(book.length==83, 'error');
    });



    // it('should parse cobol copybook PICX', function(){
    //     var script = "       77  WRK-LOCAL                   PIC  X(004)         VALUE SPACES.";
        
    //     var book = cdsParser.COBOL.COPYBOOK.loadBook(script);
        
    //     console.log(book);
    //     fs.writeFileSync('./parsed-book.CCP0000.CPY.json', JSON.stringify(book, null, 2));
        
        
    //     assert(book.length==49, 'error');
    // });

    // it('should parse cobol copybook', function(){
    //     var script = new String(fs.readFileSync('./src/cobol/CCP0001.CPY'));
        
    //     var book = cdsParser.COBOL.COPYBOOK.loadBook(script);
        
    //     console.log(book);
    //     fs.writeFileSync('./parsed-book.CCP0001.CPY.json', JSON.stringify(book, null, 2));
        
        
    //     assert(book.length==49, 'error');
    // });

    // it('should parse cobol copybook redefines', function(){
    //     var script = new String(fs.readFileSync('./src/cobol/CCP0000.CPY'));
        
    //     var book = cdsParser.COBOL.COPYBOOK.loadBook(script);
        
    //     console.log(book);
    //     fs.writeFileSync('./parsed-book.CCP0000.CPY.json', JSON.stringify(book, null, 2));
        
        
    //     assert(book.length==49, 'error');
    // });

});

