CREATE TABLE TB_SCRP_CLASSE_CLIENTE (IDENT INTEGER DEFAULT IDENTITY GENERATED BY DEFAULT NOT NULL, SIGLA_CLASSE VARCHAR(10), DESCRICAO_CLASSE VARCHAR(255) NOT NULL, TIPO_DOC_IDENT VARCHAR(30) NOT NULL, DESCR_TIPO_DOC_IDENT VARCHAR(255) NOT NULL, PRIMARY KEY (IDENT));
CREATE TABLE TB_SCRP_CLASSE_CLIENTE_HAS_SISTEMA_ORIGEM (IDENT INTEGER DEFAULT IDENTITY GENERATED BY DEFAULT NOT NULL, ID_CLASSE_CLIENTE INTEGER NOT NULL, ID_SISTEMA_ORIGEM INTEGER NOT NULL, ID_USUAR_ALTERACAO INTEGER, ID_USUAR_INCLUSAO INTEGER, ID_USUAR_EXCLUSAO INTEGER, DATA_ALTERACAO TIMESTAMP, DATA_EXCLUSAO TIMESTAMP, DATA_INCLUSAO TIMESTAMP NOT NULL, PRIMARY KEY (IDENT), CONSTRAINT CFAME052_013_001 FOREIGN KEY (ID_CLASSE_CLIENTE) REFERENCES "TB_SCRP_CLASSE_CLIENTE" ("IDENT") ON UPDATE NO ACTION ON DELETE RESTRICT, CONSTRAINT CFAME052_009_001 FOREIGN KEY (ID_SISTEMA_ORIGEM) REFERENCES "TB_SCRP_SISTEMA_ORIGEM" ("IDENT") ON UPDATE NO ACTION ON DELETE RESTRICT);
CREATE TABLE TB_SCRP_CLIENTE (IDENT INTEGER DEFAULT IDENTITY GENERATED BY DEFAULT NOT NULL, ID_PESSOA INTEGER NOT NULL, EMAIL1_CLI VARCHAR(256), EMAIL2_CLI VARCHAR(256), DDD_TEL CHAR(3), TELEFONE CHAR(9), CEP CHAR(8), LOGRADOURO VARCHAR(255), NUMERO VARCHAR(10), COMPLEMENTO VARCHAR(100), MUNICIPIO VARCHAR(80), UF CHAR(2), COD_MUNICIPIO_IBGE VARCHAR(7), CEP_COBR CHAR(8), LOGRADOURO_COBRANCA VARCHAR(255), NUMERO_COBR VARCHAR(10), COMPLEMENTO_COBR VARCHAR(100), MUNICIPIO_COBRANCA VARCHAR(80), UF_COBRANCA CHAR(2), BAIRRO VARCHAR(100), BAIRRO_COBRANCA VARCHAR(100), COD_MUNICIPIO_IBGE_COBRANCA VARCHAR(7), DATA_INCLUSAO TIMESTAMP, DATA_EXCLUSAO TIMESTAMP, DATA_ALTERACAO TIMESTAMP, ID_STATUS INTEGER, ID_USUAR_INCLUSAO INTEGER, ID_USUAR_EXCLUSAO INTEGER, ID_USUAR_ALTERACAO INTEGER, NOME_COBR VARCHAR(255), EMAIL1_COBR VARCHAR(255), EMAIL2_COBR VARCHAR(255), STATUS_BLOQUEADO SMALLINT, UNIDADE VARCHAR(14), DATA_ATUALIZACAO TIMESTAMP, PRIMARY KEY (IDENT), CONSTRAINT CFAME003_001_002 FOREIGN KEY (ID_USUAR_INCLUSAO) REFERENCES "AME_ACS"."TB_SCRP_USUARIO" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION, CONSTRAINT CFAME003_001_003 FOREIGN KEY (ID_USUAR_EXCLUSAO) REFERENCES "AME_ACS"."TB_SCRP_USUARIO" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION, CONSTRAINT CFAME003_002_001 FOREIGN KEY (ID_PESSOA) REFERENCES "TB_SCRP_PESSOA" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION);
CREATE TABLE TB_SCRP_CLIENTE_HAS_CLASSE_CLIENTE (ID_CLIENTE INTEGER NOT NULL, ID_CLASSE_CLIENTE INTEGER NOT NULL, PRIMARY KEY (ID_CLIENTE, ID_CLASSE_CLIENTE), CONSTRAINT CFAME017_013_002 FOREIGN KEY (ID_CLASSE_CLIENTE) REFERENCES "TB_SCRP_CLASSE_CLIENTE" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION, CONSTRAINT CFAME017_003_001 FOREIGN KEY (ID_CLIENTE) REFERENCES "TB_SCRP_CLIENTE" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION);
CREATE TABLE TB_SCRP_CONTRATO (IDENT INTEGER DEFAULT IDENTITY GENERATED BY DEFAULT NOT NULL, NUM_PROPOSTA VARCHAR(16), NUM_CONTRATO VARCHAR(15), DATA_EMISSAO TIMESTAMP, DATA_ASSINATURA TIMESTAMP, ID_STATUS INTEGER, ID_CLIENTE INTEGER, ID_MODELO_CONTRATO INTEGER, ID_USUAR_ALTERACAO INTEGER, ID_USUAR_INCLUSAO INTEGER, ID_USUAR_EXCLUSAO INTEGER, DATA_ALTERACAO TIMESTAMP, DATA_EXCLUSAO TIMESTAMP, DATA_INCLUSAO TIMESTAMP, FLAG_VIEW_CLIENTE CHAR(1) DEFAULT 'S', PRIMARY KEY (IDENT), CONSTRAINT CFAME027_003_001 FOREIGN KEY (ID_CLIENTE) REFERENCES "TB_SCRP_CLIENTE" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION, CONSTRAINT CFAME027_015_003 FOREIGN KEY (ID_MODELO_CONTRATO) REFERENCES "TB_SCRP_MODELO_CONTRATO" ("IDENT") ON UPDATE NO ACTION ON DELETE RESTRICT, CONSTRAINT CFAME027_010_001 FOREIGN KEY (ID_STATUS) REFERENCES "TB_SCRP_STATUS" ("IDENT") ON UPDATE NO ACTION ON DELETE RESTRICT);
CREATE TABLE TB_SCRP_CONTRATO_DETRAN (IDENT INTEGER DEFAULT IDENTITY GENERATED BY DEFAULT NOT NULL, ID_CONTRATO INTEGER NOT NULL, ID_CONTRATO_DETRAN INTEGER NOT NULL, DATA_ALTERACAO TIMESTAMP, DATA_INCLUSAO TIMESTAMP NOT NULL, PRIMARY KEY (IDENT), CONSTRAINT CFAME046_027_001 FOREIGN KEY (ID_CONTRATO) REFERENCES "TB_SCRP_CONTRATO" ("IDENT") ON UPDATE NO ACTION ON DELETE RESTRICT);
CREATE TABLE TB_SCRP_CONTRATO_HAS_DOCUMENTOS_CLIENTE (ID_CONTRATO INTEGER NOT NULL, ID_DOCUMENTOS_CLIENTE INTEGER NOT NULL, ID_STATUS INTEGER, DATA_EXCLUSAO TIMESTAMP, DATA_INCLUSAO TIMESTAMP, DATA_ALTERACAO TIMESTAMP, ID_USUAR_EXCLUSAO INTEGER, ID_USUAR_INCLUSAO INTEGER, ID_USUAR_ALTERACAO INTEGER, PRIMARY KEY (ID_CONTRATO, ID_DOCUMENTOS_CLIENTE), CONSTRAINT CFAME029_027_001 FOREIGN KEY (ID_CONTRATO) REFERENCES "TB_SCRP_CONTRATO" ("IDENT") ON UPDATE NO ACTION ON DELETE RESTRICT, CONSTRAINT CFAME029_028_001 FOREIGN KEY (ID_DOCUMENTOS_CLIENTE) REFERENCES "TB_SCRP_DOCUMENTOS_CLIENTE" ("IDENT") ON UPDATE NO ACTION ON DELETE RESTRICT);
CREATE TABLE TB_SCRP_DOCUMENTOS_CLIENTE (IDENT INTEGER DEFAULT IDENTITY GENERATED BY DEFAULT NOT NULL, ID_CLIENTE INTEGER, ID_TIPO_DOCUMENTO INTEGER, ID_STATUS INTEGER, DATA_VALIDADE DATE, DOCUMENTO BLOB, OBSERVACAO VARCHAR(256), TIPO_ARQUIVO VARCHAR(20), NUM_DOCUMENTO VARCHAR(30), CLASSE_EMPRESA VARCHAR(10), COD_ATIV_ECONOMICA VARCHAR(10), DB2_GENERATED_ROWID_FOR_LOBS ROWID DEFAULT ROWID GENERATED ALWAYS NOT NULL, DATA_INCLUSAO TIMESTAMP, DATA_EXCLUSAO TIMESTAMP, DATA_ALTERACAO TIMESTAMP, ID_USUAR_EXCLUSAO INTEGER, ID_USUAR_INCLUSAO INTEGER, ID_USUAR_ALTERACAO INTEGER, PRIMARY KEY (IDENT), CONSTRAINT CFAME028_003_001 FOREIGN KEY (ID_CLIENTE) REFERENCES "TB_SCRP_CLIENTE" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION, CONSTRAINT CFAME028_010_003 FOREIGN KEY (ID_STATUS) REFERENCES "TB_SCRP_STATUS" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION);
CREATE TABLE TB_SCRP_MODELO_CONTRATO (IDENT INTEGER DEFAULT IDENTITY GENERATED BY DEFAULT NOT NULL, COD_COMERCIAL VARCHAR(15), DESCRICAO_MODELO VARCHAR(200), INICIO_VIGENCIA DATE, FIM_VIGENCIA DATE, TITULO_CONTRATO VARCHAR(100), ID_SISTEMA_ORIGEM INTEGER, ID_STATUS INTEGER, CONTEUDO_MODELO CLOB, DB2_GENERATED_ROWID_FOR_LOBS ROWID DEFAULT ROWID GENERATED ALWAYS NOT NULL, DATA_EXCLUSAO TIMESTAMP, DATA_INCLUSAO TIMESTAMP, DATA_ALTERACAO TIMESTAMP, ID_USUAR_EXCLUSAO INTEGER, ID_USUAR_INCLUSAO INTEGER, ID_USUAR_ALTERACAO INTEGER, TIPO_RENOVACAO CHAR(1), QTD_MESES_VALID INTEGER, PRIMARY KEY (IDENT), CONSTRAINT CFAME015_009_001 FOREIGN KEY (ID_SISTEMA_ORIGEM) REFERENCES "TB_SCRP_SISTEMA_ORIGEM" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION, CONSTRAINT CFAME015_010_002 FOREIGN KEY (ID_STATUS) REFERENCES "TB_SCRP_STATUS" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION);
CREATE TABLE TB_SCRP_PESSOA (IDENT INTEGER DEFAULT IDENTITY GENERATED BY DEFAULT NOT NULL, TP_PESSOA CHAR(1) NOT NULL, CPF_PESSOA VARCHAR(11), NOME_PESSOA VARCHAR(200), CNPJ_PESSOA VARCHAR(14), RAZAO_SOCIAL VARCHAR(200), DATA_INCLUSAO TIMESTAMP, DATA_EXCLUSAO TIMESTAMP, ID_STATUS INTEGER, ID_USUAR_INCLUSAO INTEGER, ID_USUAR_EXCLUSAO INTEGER, ID_USUAR_ALTERACAO INTEGER, DATA_ALTERACAO TIMESTAMP, UNIDADE VARCHAR(14), PRIMARY KEY (IDENT), CONSTRAINT CFAME002_001_003 FOREIGN KEY (ID_USUAR_EXCLUSAO) REFERENCES "AME_ACS"."TB_SCRP_USUARIO" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION, CONSTRAINT CFAME002_001_002 FOREIGN KEY (ID_USUAR_INCLUSAO) REFERENCES "AME_ACS"."TB_SCRP_USUARIO" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION, CONSTRAINT CFAME002_010_001 FOREIGN KEY (ID_STATUS) REFERENCES "TB_SCRP_STATUS" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION);
CREATE TABLE TB_SCRP_SISTEMA_ORIGEM (IDENT INTEGER DEFAULT IDENTITY GENERATED BY DEFAULT NOT NULL, SIGLA_SISTEMA CHAR(6) NOT NULL, NOME_SISTEMA VARCHAR(100), DESCRICAO_SISTEMA VARCHAR(255), FLAG_CADASTRO_MANUAL CHAR(1) NOT NULL, FLAG_DOCUMENTO CHAR(1) NOT NULL, ID_STATUS INTEGER NOT NULL, TIPO_ATUALIZ_CADASTRAL INTEGER DEFAULT 0 NOT NULL, DATA_INCLUSAO TIMESTAMP, DATA_EXCLUSAO TIMESTAMP, ID_USUAR_INCLUSAO INTEGER, ID_USUAR_EXCLUSAO INTEGER, DATA_ALTERACAO TIMESTAMP, ID_USUAR_ALTERACAO INTEGER, PRIMARY KEY (IDENT), CONSTRAINT CFAME009_010_001 FOREIGN KEY (ID_STATUS) REFERENCES "TB_SCRP_STATUS" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION);
CREATE TABLE TB_SCRP_SISTEMA_ORIGEM_HAS_TIPO_DOCUMENTO (IDENT INTEGER DEFAULT IDENTITY GENERATED ALWAYS NOT NULL, ID_SISTEMA_ORIGEM INTEGER NOT NULL, ID_TIPO_DOCUMENTO INTEGER NOT NULL, ID_STATUS INTEGER, ID_USUAR_ALTERACAO INTEGER, ID_USUAR_INCLUSAO INTEGER, ID_USUAR_EXCLUSAO INTEGER, DATA_ALTERACAO TIMESTAMP, DATA_INCLUSAO TIMESTAMP, DATA_EXCLUSAO TIMESTAMP, FLAG_UPLOAD_OBRIGATORIO CHAR(1) DEFAULT 'S', PRIMARY KEY (IDENT), CONSTRAINT CFAME026_009_001 FOREIGN KEY (ID_SISTEMA_ORIGEM) REFERENCES "TB_SCRP_SISTEMA_ORIGEM" ("IDENT") ON UPDATE NO ACTION ON DELETE NO ACTION, CONSTRAINT CFAME026_014_002 FOREIGN KEY (ID_TIPO_DOCUMENTO) REFERENCES "TB_SCRP_TIPO_DOCUMENTO" ("IDENT") ON UPDATE NO ACTION ON DELETE RESTRICT);
CREATE TABLE TB_SCRP_SISTEMA_ORIGEM_HAS_TIPO_DOCUMENTO_BU0 (ID_SISTEMA_ORIGEM INTEGER NOT NULL, ID_TIPO_DOCUMENTO INTEGER NOT NULL, ID_STATUS INTEGER, ID_USUAR_ALTERACAO INTEGER, ID_USUAR_INCLUSAO INTEGER, ID_USUAR_EXCLUSAO INTEGER, DATA_ALTERACAO TIMESTAMP, DATA_INCLUSAO TIMESTAMP, DATA_EXCLUSAO TIMESTAMP, FLAG_UPLOAD_OBRIGATORIO CHAR(1) DEFAULT 'S');
